// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Der Mähroboter geht gerade aus, bis er auf einen Zaun trifft (braunes Hindernis).
 * @author Albert Wiedemann @version 1.0
 */
public class Maehroboter extends Figur
{
    protected int batteriestand;

    /**
     * Der Konstruktor erzeugt die Form, den Zaun und die Rasenfläche
     */
    protected Maehroboter()
    {
        super();
        FigurteilFestlegenRechteck(-50, -40, 20, 10, "schwarz");
        FigurteilFestlegenRechteck(-50, 30, 20, 10, "schwarz");
        FigurteilFestlegenRechteck(30, -40, 20, 10, "schwarz");
        FigurteilFestlegenRechteck(30, 30, 20, 10, "schwarz");
        FigurteilFestlegenEllipse(-50, -40, 100, 80, "cyan");
        FigurteilFestlegenDreieck(5, -10, 45, 0, 5, 10, "rot");
        PositionSetzen(300, 400);
        Drehen(90);
        batteriestand = 200;
         new  Rasen();
         new  ZaunNord();
         new  ZaunWest();
         new  ZaunOst();
         new  ZaunSued();
        GanzNachVornBringen();
    }

    /**
     * Mäht so lange, so lange kein Hindernis kommt.
     */
    protected void BisZaunMähen()
    {
        while ( ! Berührt("braun")) {
            /* ! bedeutet NICHT*/
            FahrenUndMähen();
        }
    }

    /**
     * Mäht so lange, so lange kein Hindernis kommt.
     */
    protected void Mähen()
    {
        BisZaunMähen();
        Drehen(80);
        System.out.println(WinkelGeben());
        Gehen(10);
    }

    /**
     * Simulation des Mähvorgangs.
     */
    protected void FahrenUndMähen()
    {
        Gehen(5);
        MähspurDarstellen();
        BatteriestandUm1Reduzieren();
        System.out.println("Batteriestand " + BatteriestandGeben());
    }

    /* Hilfsmethoden, die als Black Box verwendet werden können*/

    /**
     * Meldet den Batteriestand. @returns Batteriestand
     */
    protected int BatteriestandGeben()
    {
        return batteriestand;
    }

    /**
     * Erhöht den Batteriestand um 1.
     */
    protected void BatteriestandUm1Reduzieren()
    {
        batteriestand = batteriestand - 1;
    }

    /**
     * Im Anzeigefenster eine Mähspur darstellen.
     */
    private void MähspurDarstellen()
    {
        Rechteck r;
        r =  new  Rechteck();
        GrafikWelt.dieWelt.addObject(r, 0, 0);
        r.FarbeSetzen("hellgrün");
        if (WinkelGeben() > 45 && WinkelGeben() <= 135) {
            r.GrößeSetzen(20, 5);
            r.PositionSetzen(XPositionGeben() - 10, YPositionGeben() + 25);
        }
        else if (WinkelGeben() > 135 && WinkelGeben() <= 225) {
            r.GrößeSetzen(5, 20);
            r.PositionSetzen(XPositionGeben() - 25, YPositionGeben() - 10);
        }
        if (WinkelGeben() > 225 && WinkelGeben() <= 315) {
            r.GrößeSetzen(20, 5);
            r.PositionSetzen(XPositionGeben() - 10, YPositionGeben() - 35);
        }
        if (WinkelGeben() > 315 || WinkelGeben() <= 45) {
            r.GrößeSetzen(5, 20);
            r.PositionSetzen(XPositionGeben() + 25, YPositionGeben() - 10);
        }
        GanzNachVornBringen();
        try {
            Thread.sleep(50);
        }
        catch (InterruptedException e) {
        }
    }

    /**
     * Drehen und den Drehwinkel im INtervall [0;360[ halten.
     */
    protected void Drehen(int grad)
    {
        super.Drehen(grad);
        if (WinkelGeben() >= 360) {
            WinkelSetzen(WinkelGeben() - 360);
        }
        else if (WinkelGeben() < 0) {
            WinkelSetzen(WinkelGeben() + 360);
        }
    }
}
